


# naive implementatie: Fibonacci-rij
def Fibonacci1(n):
	# base case
	if (n == 0) or (n == 1):
		return n

	# normal case
	return Fibonacci1(n-1)+Fibonacci1(n-2)

# # hoofdprogramma
# from time import time
# for i in range(40):
# 	# print (f'het {i}de element in de Rij van Fibonacci is:' \
# 	# 	, Fibonacci1(i))
# 	starttijd = time()
# 	fib = Fibonacci1(i)
# 	eindtijd = time()
# 	print (i, fib, eindtijd-starttijd)


#  8 [Finished in 118ms]
# 40 [Finished in 57.5s]

def Fibonacci2(n):
	# base case
	if (n == 0) or (n == 1):
		return n

	rij = [0]*(n+1) # een lege lijst met de lengte n+1
	# geef de eerste twee elementen
	rij[0] = 0
	rij[1] = 1

	# rij aanvullen
	for i in range(2, n+1):
		rij[i] = rij[i-1] + rij[i-2]

	return rij[-1]


# hoofdprogramma
from time import time
looptijden = []
for i in range(40):
	# print (f'het {i}de element in de Rij van Fibonacci is:' \
	# 	, Fibonacci1(i))
	starttijd = time()
	fib = Fibonacci1(i)
	eindtijd = time()
	print (i, fib, eindtijd-starttijd)
	looptijden.append(eindtijd-starttijd)

import matplotlib.pyplot as PLT
PLT.plot(looptijden)
PLT.show()